"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require("./");
describe('keyboard manager', function () {
    it('should manage keyboard shortcuts', function () {
        var triggered = 0;
        var keyboard = new _1.Keyboard();
        var event1 = { which: 'A'.charCodeAt(0), metaKey: true };
        var event2 = { which: 0 };
        var handler = keyboard.getHandler();
        var listener = _1.createShortcuts((_a = {},
            _a[_1.stringifyKey('cmd', 'a')] = function () { triggered++; },
            _a));
        keyboard.addListener(listener);
        handler(event1);
        handler(event2);
        keyboard.removeListener(listener);
        handler(event1);
        handler(event2);
        expect(triggered).toEqual(1);
        var _a;
    });
    it('should support a "global" pattern', function () {
        var dispatcher = new _1.Keyboard();
        var handler = dispatcher.getHandler();
        var appTriggered = 0;
        var globalTriggered = 0;
        var appKeyboard = new _1.Keyboard();
        var globalKeyboard = new _1.Keyboard();
        dispatcher.addListener(appKeyboard.getListener());
        dispatcher.addListener(globalKeyboard.getListener());
        globalKeyboard.addListener(_1.createShortcuts((_a = {},
            _a[_1.stringifyKey('cmd', 'a')] = function () { globalTriggered++; },
            _a)));
        appKeyboard.addListener(_1.createShortcuts((_b = {},
            _b[_1.stringifyKey('a')] = function () { appTriggered++; },
            _b[_1.stringifyKey('cmd', 'a')] = function () { appTriggered++; },
            _b)));
        handler({ which: 'A'.charCodeAt(0), metaKey: true });
        expect(appTriggered).toEqual(0);
        expect(globalTriggered).toEqual(1);
        handler({ which: 'A'.charCodeAt(0) });
        expect(appTriggered).toEqual(1);
        expect(globalTriggered).toEqual(1);
        var _a, _b;
    });
});
//# sourceMappingURL=index.spec.js.map